<?php
/**
 *
 */

/**
 *
 */
class Context {
  
  var $dom;
  var $root;
  var $general;
  var $window;
  var $list;
  
  function Context( $node ) {
    $this->dom = new DOMDocument( '1.0', 'UTF-8' );
    $this->dom->formatOutput = TRUE;
    
    $this->root = $this->init();
    
    $this->general->appendChild( $this->dom->createElement( 'Title', $node->title ) );
    $this->window = $this->general->appendChild( $this->dom->createElement( 'Window' ) );
  }
  
  function init() {
    $this->root = $root = $this->dom->createElement( 'ViewContext' );
    $root->setAttribute( 'version', '1.0.0' );
    $root->setAttribute( 'xmlns', "http://www.opengis.net/context" );
    $root->setAttribute( 'xmlns:xlink', "http://www.w3.org/1999/xlink" );
    $root->setAttribute( 'xmlns:xsi', "http://www.w3.org/2001/XMLSchema-instance" );

    $root->setAttribute( 'xsi:schemaLocation', "http://www.opengis.net/context http://schemas.opengis.net/context/1.0.0/context.xsd" );

    $this->general = $this->root->appendChild( $this->dom->createElement( 'General' ) );
    $this->list = $this->root->appendChild( $this->dom->createElement( 'LayerList' ) );
    
    return $this->dom->appendChild( $root );
  }
  
  function setWindow($width, $height) {
    $this->window->setAttribute( 'width', $width );
    $this->window->setAttribute( 'height', $height );
  }
  
  function setBoundingBox( $bboxStr ) {
    $bbox = explode( ',', $bboxStr );
    $bboxNode = $this->general->appendChild( $this->dom->createElement( 'BoundingBox' ) );
    $bboxNode->setAttribute( 'SRS', $bbox[0] );
    $bboxNode->setAttribute( 'minx', $bbox[1] );
    $bboxNode->setAttribute( 'miny', $bbox[2] );
    $bboxNode->setAttribute( 'maxx', $bbox[3] );
    $bboxNode->setAttribute( 'maxy', $bbox[4] );
  }
  
  function addLayer($layerData) {
    $layer = $this->dom->createElement( 'Layer' );
    $layer->setAttribute( 'hidden', $layerData['hidden'] );
    $layer->setAttribute( 'queryable', $layerData['queryable'] );
    $server = $layer->appendChild( $this->dom->createElement( 'Server' ) );
    $server->setAttribute( 'version', $layerData['version'] );
    $server->setAttribute( 'service', "OGC:WMS" );
    $onlineResource = $server->appendChild( $this->dom->createElement( 'OnlineResource' ) );
    $onlineResource->setAttribute( 'xlink:type', 'simple' );
    $onlineResource->setAttribute( 'xlink:href', $layerData['href'] );
    $layer->appendChild( $this->dom->createElement( 'Name', $layerData['names'] ) );
    $layer->appendChild( $this->dom->createElement( 'Title', $layerData['layer_title'] ) );
    
    $this->list->appendChild( $layer );
  }
  
  function getXML() {
    return $this->dom->saveXML();
  }
}

/**
 *
 */
class OwsContext extends Context {
  
  function OwsContext( $node ) {
    parent::Context( $node );
  }
  
  function init() {
    $this->root = $root = $this->dom->createElement('OWSContext');
    $root->setAttribute( 'version', '0.0.13' );
    $root->setAttribute( 'xmlns', "http://www.opengis.net/context" );
    $root->setAttribute( 'xmlns:xlink', "http://www.w3.org/1999/xlink" );
    $root->setAttribute( 'xmlns:xsi', "http://www.w3.org/2001/XMLSchema-instance" );

    $root->setAttribute('xmlns:sld', "http://www.opengis.net/sld");
    $root->setAttribute('xmlns:ogc', "http://www.opengis.net/ogc");
    $root->setAttribute('xmlns:ows', "http://www.opengis.net/ows");
    $root->setAttribute('xmlns:param', "http;//www.opengis.net/param");
    $root->setAttribute('xsi:schemaLocation', "http://www.opengis.net/oc oc_0_0_13.xsd");

    $this->general = $this->root->appendChild( $this->dom->createElement( 'General' ) );
    $this->list = $this->root->appendChild( $this->dom->createElement( 'ResourceList' ) );
    
    return $this->dom->appendChild( $root );
  }
  
  function setBoundingBox( $bboxStr ) {
    $bbox = explode( ',', $bboxStr );
    
    $node = $this->general->appendChild( $this->dom->createElement( 'ows:BoundingBox' ) );
    $node->setAttribute( 'crs', $bbox[0] );
    $node->appendChild( $this->dom->createElement('ows:LowerCorner', $bbox[1].' '.$bbox[2]) );
    $node->appendChild( $this->dom->createElement('ows:UpperCorner', $bbox[3].' '.$bbox[4]) );
  }
  
}

?>
